/**
 * Generates input IDs or names based on the provided attributes, range, and position.
 *
 * @param attribute - A single string or a tuple of two strings representing the attribute names.
 * @param range - A boolean indicating whether the input is part of a range.
 * @param position - Optional. Specifies the position ('start' or 'end') when `range` is true.
 * @returns A string representing the input ID or name.
 */
export declare const getInputIdOrName: (attribute: string | [string, string], range: boolean, position?: "start" | "end") => string;
/**
 * Parses a date string into a Date object based on the provided locale and time inclusion.
 *
 * @param dateString - The date string to parse.
 * @param locale - The locale to use for parsing the date string.
 * @param includeTime - Optional. Determines whether to include time in the parsed Date object.
 * @returns A Date object representing the parsed date and time, or `undefined` if parsing fails.
 */
export declare const getLocalDateFromString: (string: string, locale: string, time?: boolean) => Date | undefined;
