'use strict';

var React = require('react');

var useDebounce = function (value, delay) {
    var _a = React.useState(value), debouncedValue = _a[0], setDebouncedValue = _a[1];
    React.useEffect(function () {
        var handler = setTimeout(function () {
            setDebouncedValue(value);
        }, delay);
        return function () {
            clearTimeout(handler);
        };
    }, [value, delay]);
    return debouncedValue;
};

exports.useDebounce = useDebounce;
//# sourceMappingURL=useDebounce.js.map
