'use strict';

var React = require('react');

var useIsVisible = function (ref) {
    var _a = React.useState(false), isIntersecting = _a[0], setIntersecting = _a[1];
    React.useEffect(function () {
        var observer = new IntersectionObserver(function (_a) {
            var entry = _a[0];
            return setIntersecting(entry.isIntersecting);
        });
        ref.current && observer.observe(ref.current);
        return function () { return observer.disconnect(); };
    }, []);
    return isIntersecting;
};

exports.useIsVisible = useIsVisible;
//# sourceMappingURL=useIsVisible.js.map
