import type { Column, ColumnFilter, ColumnFilterValue, Group, Item, Sorter, SorterValue, TableFilter } from './types';
export declare const filterColumns: (items: Item[], columnFilter: boolean | ColumnFilter | undefined, columnFilterState: ColumnFilterValue, itemsDataColumns: string[]) => Item[];
export declare const filterTable: (items: Item[], tableFilter: boolean | TableFilter | undefined, tableFilterState: string, itemsDataColumns: string[]) => Item[];
export declare const getClickedColumnName: (target: HTMLElement, columnNames: string[], selectable?: boolean) => string;
export declare const getColumnKey: (column: Column | string) => string;
export declare const getColumnLabel: (column: Column | string) => string;
export declare const getColumnName: (column: Column | string) => string;
export declare const getColumnNames: (columns: (string | Column)[] | undefined, items: Item[]) => string[];
export declare const getColumns: (_columns: (Column | Group | string)[]) => (Column | string)[];
export declare const countColumns: (columns: Column[]) => number;
export declare const getColumnGroups: (columns: (string | Column)[] | undefined) => Group[][];
export declare const getColumnNamesFromItems: (items: Item[]) => string[];
export declare const getColumnSorterFunction: (column: Column | undefined) => ((a: any, b: any) => number) | undefined;
export declare const getColumnSorterState: (key: string, sorterState?: SorterValue[]) => string | number;
export declare const getColumnValues: (items: Item[], key: string) => any[];
export declare const getTableDataCellProps: (column: Column | string, item: Item, colName: string) => Record<string, any>;
export declare const getTableDataCellStyles: (column: Column | string, item: Item, colName: string) => Record<string, any>;
export declare const getTableHeaderCellProps: (column: Column | string) => import("../table/CTableHeaderCell").CTableHeaderCellProps;
export declare const getTableHeaderCellStyles: (column: Column | string, columnSorter: boolean | Sorter | undefined) => Record<string, any>;
export declare const isSortable: (index: number, columns: (string | Column)[] | undefined, columnSorter: boolean | Sorter | undefined, itemsDataColumns: string[], columnNames: string[]) => boolean;
export declare const pretifyName: (name: string) => string;
export declare const sortBy: (column: Column | undefined, items: Item[], key: string, order: SorterValue["state"]) => Item[];
export declare const sortItems: (columns: (Column | string)[] | undefined, columnSorter: boolean | Sorter | undefined, items: Item[], itemsDataColumns: string[], sorterState: SorterValue[]) => Item[];
